<component>
  <actions>
    <action id="IncrementalSearch" class="com.intellij.codeInsight.navigation.actions.IncrementalSearchAction"/>
    <action id="AddToFavoritesPopup" class="com.intellij.ide.favoritesTreeView.actions.AddToFavoritesPopupAction"/>
    <group id="AddToFavorites" class="com.intellij.ide.favoritesTreeView.actions.AddToFavoritesActionGroup" popup="true"/>
    <group id="AddAllToFavorites" class="com.intellij.ide.favoritesTreeView.actions.AddAllToFavoritesActionGroup" popup="true"/>
    <action id="AddNewFavoritesList" class="com.intellij.ide.favoritesTreeView.actions.AddNewFavoritesListAction"/>
    <group id="SendToFavoritesGroup" class="com.intellij.ide.favoritesTreeView.actions.SendToFavoritesGroup" popup="true"/>

    <action id="RunConfiguration" class="com.intellij.execution.actions.RunConfigurationsComboBoxAction"/>
    <action id="ChooseRunConfiguration" class="com.intellij.execution.actions.ChooseRunConfigurationPopupAction" text="Run..." description="Choose and run configuration" icon="AllIcons.Toolwindows.ToolWindowRun"/>
    <action id="ChooseDebugConfiguration" class="com.intellij.execution.actions.ChooseDebugConfigurationPopupAction" text="Debug..." description="Choose and debug configuration" icon="AllIcons.General.Debug"/>

    <group id="RunContextGroup" popup="false">
      <action id="CreateRunConfiguration" class="com.intellij.execution.actions.CreateAction"/>
    </group>
    <group id="RunContextPopupGroup" popup="false">
      <reference ref="RunContextGroup"/>
    </group>

    <group id="LangCodeInsightActions">
      <action id="EditorSelectWord" class="com.intellij.openapi.editor.actions.SelectWordAtCaretAction"/>
      <action id="EditorUnSelectWord" class="com.intellij.openapi.editor.actions.UnselectWordAtCaretAction"/>

      <add-to-group group-id="EditorActions" anchor="last"/>
    </group>

    <action id="ClassNameCompletion" class="com.intellij.codeInsight.completion.actions.ClassNameCompletionAction"/>

    <group id="GenerateGroup">
      <action id="OverrideMethods" class="com.intellij.codeInsight.generation.actions.OverrideMethodsAction"/>
      <action id="ImplementMethods" class="com.intellij.codeInsight.generation.actions.ImplementMethodsAction"/>
      <action id="DelegateMethods" class="com.intellij.codeInsight.generation.actions.DelegateMethodsAction"/>
      <action id="GeneratePattern" class="com.intellij.codeInsight.generation.GenerateByPatternAction" text="Generate by Pattern..."/>
    </group>

    <action id="ShowIntentionActions" class="com.intellij.codeInsight.intention.actions.ShowIntentionActionsAction"/>

    <action id="TogglePopupHints" class="com.intellij.ide.actions.TogglePopupHintsAction"/>
    <action id="FindModal" class="com.intellij.openapi.editor.actions.FindAction" icon="AllIcons.Actions.Menu_find"/>

    <action id="CodeInspection.OnEditor" class="com.intellij.codeInspection.actions.CodeInspectionOnEditorAction"/>

    <action id="ActivateNavBar" class="com.intellij.ide.navigationToolbar.ActivateNavigationBarAction" popup="true"/>

    <action id="EditorIndentLineOrSelection" class="com.intellij.openapi.editor.actions.IndentLineOrSelectionAction"/>

    <group id="CodeInsightEditorActions">
      <reference ref="LookupActions"/>
      <action id="EmacsStyleIndent" class="com.intellij.codeInsight.editorActions.EmacsStyleIndentAction"/>
      <action id="EditorCodeBlockStart" class="com.intellij.codeInsight.editorActions.CodeBlockStartAction"/>
      <action id="EditorCodeBlockEnd" class="com.intellij.codeInsight.editorActions.CodeBlockEndAction"/>
      <action id="EditorMatchBrace" class="com.intellij.codeInsight.editorActions.MatchBraceAction"/>
      <action id="EditorCodeBlockStartWithSelection" class="com.intellij.codeInsight.editorActions.CodeBlockStartWithSelectionAction"/>
      <action id="EditorCodeBlockEndWithSelection" class="com.intellij.codeInsight.editorActions.CodeBlockEndWithSelectionAction"/>
      <action id="EditorCompleteStatement" class="com.intellij.codeInsight.editorActions.smartEnter.SmartEnterAction"/>

      <add-to-group group-id="EditorActions" anchor="last"/>
    </group>

    <!-- File -->

    <action id="ReloadFromDisk" class="com.intellij.ide.actions.ReloadFromDiskAction">
      <!--
      <add-to-group group-id="FileMenu" anchor="after" relative-to-action="Synchronize"/>
      -->
    </action>


    <group id="PrintExportGroup">
      <separator/>
      <action id="ExportToHTML" class="com.intellij.codeEditor.printing.ExportToHTMLAction"/>
      <action id="Print" class="com.intellij.codeEditor.printing.PrintAction" icon="AllIcons.Graph.Print"/>
      <reference ref="AddToFavorites"/>

      <add-to-group group-id="FileMenu" anchor="after" relative-to-action="InvalidateCaches"/>
    </group>

    <action id="ChangeTemplateDataLanguage" class="com.intellij.psi.templateLanguages.ChangeTemplateDataLanguageAction">
      <add-to-group group-id="FileMenu" anchor="before" relative-to-action="ToggleReadOnlyAttribute"/>
    </action>

    <group id="PowerSaveGroup">
      <separator/>
      <action id="TogglePowerSave" class="com.intellij.ide.actions.TogglePowerSaveAction"/>
      <add-to-group group-id="FileMenu" anchor="after" relative-to-action="ToggleReadOnlyAttribute"/>
    </group>

    <!-- Edit -->
    <action id="CopyReference" class="com.intellij.ide.actions.CopyReferenceAction">
      <add-to-group group-id="CutCopyPasteGroup" anchor="after" relative-to-action="CopyPaths"/>
      <add-to-group group-id="EditorTabPopupMenu" anchor="after" relative-to-action="CopyPaths"/>
      <add-to-group group-id="EditorPopupMenu" anchor="after" relative-to-action="$Copy"/>
    </action>

    <group id="EditSelectWordGroup">
      <reference ref="EditorSelectWord"/>
      <reference ref="EditorUnSelectWord"/>

      <add-to-group group-id="EditSelectGroup" anchor="last"/>
    </group>

    <group id="EditBookmarksGroup" popup="true">
      <action id="ToggleBookmark" class="com.intellij.ide.bookmarks.actions.ToggleBookmarkAction"/>
      <action id="ToggleBookmarkWithMnemonic" class="com.intellij.ide.bookmarks.actions.ToggleBookmarkWithMnemonicAction"/>
      <action id="ShowBookmarks" class="com.intellij.ide.bookmarks.actions.BookmarksAction"/>
      <action id="GotoNextBookmark" class="com.intellij.ide.bookmarks.actions.NextBookmarkAction"/>
      <action id="GotoPreviousBookmark" class="com.intellij.ide.bookmarks.actions.PreviousBookmarkAction"/>
      <separator/>

      <add-to-group group-id="GoToMenu" anchor="after" relative-to-action="JumpToLastChange"/>
    </group>

    <group id="GoToCodeGroup">
      <separator/>
      <action id="SelectIn" class="com.intellij.ide.actions.SelectInAction"/>
      <action id="ShowNavBar" class="com.intellij.ide.navigationToolbar.ShowNavBarAction"/>
      <action id="GotoDeclaration" class="com.intellij.codeInsight.navigation.actions.GotoDeclarationAction"/>
      <action id="GotoImplementation" class="com.intellij.codeInsight.navigation.actions.GotoImplementationAction"/>
      <action id="GotoTypeDeclaration" class="com.intellij.codeInsight.navigation.actions.GotoTypeDeclarationAction"/>
      <action id="GotoSuperMethod" class="com.intellij.codeInsight.navigation.actions.GotoSuperAction"/>
      <action id="GotoTest" class="com.intellij.testIntegration.GotoTestOrCodeAction"/>
      <action id="GotoRelated" class="com.intellij.ide.actions.GotoRelatedFileAction"/>
      <separator/>
      <action id="FileStructurePopup" class="com.intellij.ide.actions.ViewStructureAction"/>
      <action id="ShowFilePath" class="com.intellij.ide.actions.ShowFilePathAction"/>
      <group id="HierarchyGroup">
        <action id="TypeHierarchy" class="com.intellij.ide.hierarchy.actions.BrowseTypeHierarchyAction"/>
        <action id="MethodHierarchy" class="com.intellij.ide.hierarchy.actions.BrowseMethodHierarchyAction"/>
        <action id="CallHierarchy" class="com.intellij.ide.hierarchy.actions.BrowseCallHierarchyAction"/>
      </group>
      <separator/>

      <add-to-group group-id="GoToMenu" anchor="after" relative-to-action="EditBookmarksGroup"/>
    </group>

    <group id="GoToErrorGroup">
      <separator/>
      <action id="GotoNextError" class="com.intellij.codeInsight.daemon.impl.actions.GotoNextErrorAction"/>
      <action id="GotoPreviousError" class="com.intellij.codeInsight.daemon.impl.actions.GotoPreviousErrorAction"/>

      <add-to-group group-id="GoToMenu" anchor="after" relative-to-action="GoToCodeGroup"/>
    </group>

    <!-- View -->
    <group id="QuickActions">
      <separator/>
      <action id="QuickImplementations" class="com.intellij.codeInsight.hint.actions.ShowImplementationsAction"/>
      <action id="QuickJavaDoc" class="com.intellij.codeInsight.documentation.actions.ShowQuickDocInfoAction"/>

      <add-to-group group-id="ViewMenu" anchor="after" relative-to-action="ToolWindowsGroup"/>
    </group>

    <group id="CodeEditorBaseGroup">
      <group id="CodeEditorViewGroup">
        <action id="ExternalJavaDoc" class="com.intellij.ide.actions.ExternalJavaDocAction"/>
        <action id="ParameterInfo" class="com.intellij.codeInsight.hint.actions.ShowParameterInfoAction"/>
        <action id="EditorContextInfo" class="com.intellij.codeInsight.hint.actions.ShowContainerInfoAction"/>
        <action id="ShowErrorDescription" class="com.intellij.codeInsight.daemon.impl.actions.ShowErrorDescriptionAction"/>
      </group>
      <separator/>

      <add-to-group group-id="ViewMenu" relative-to-action="QuickActions" anchor="after"/>
    </group>

    <action id="FixDocComment" class="com.intellij.codeInsight.editorActions.FixDocCommentAction"/>

    <action id="ViewNavigationBar" class="com.intellij.ide.actions.ViewNavigationBarAction">
      <add-to-group group-id="UIToggleActions" relative-to-action="ViewStatusBar" anchor="after"/>
    </action>

    <action id="ViewImportPopups" class="com.intellij.openapi.editor.actions.ToggleShowImportPopupsAction">
      <add-to-group group-id="EditorToggleActions"/>
    </action>

    <action id="ProjectViewChangeView" class="com.intellij.ide.projectView.actions.ChangeProjectViewAction"/>

    <action id="RecentChanges" class="com.intellij.history.integration.ui.actions.RecentChangesAction">
      <keyboard-shortcut first-keystroke="alt shift C" keymap="$default"/>
      <add-to-group group-id="ViewRecentActions" anchor="last"/>
    </action>

    <!-- Go To -->
    <group id="GoToTargetEx">
      <action id="GotoClass" class="com.intellij.ide.actions.GotoClassAction"/>
      <action id="GotoFile" class="com.intellij.ide.actions.GotoFileAction"/>
      <action id="GotoSymbol" class="com.intellij.ide.actions.GotoSymbolAction"/>
      <action id="GotoCustomRegion" class="com.intellij.lang.customFolding.GotoCustomRegionAction"/>

      <add-to-group group-id="GoToMenu" anchor="first"/>
    </group>

    <group id="GoToMenuEx">
      <separator/>
      <action id="MethodDown" class="com.intellij.codeInsight.navigation.actions.MethodDownAction"/>
      <action id="MethodUp" class="com.intellij.codeInsight.navigation.actions.MethodUpAction"/>
      <separator/>
      <add-to-group group-id="GoToMenu" anchor="after" relative-to-action="GoToPreviousError"/>
    </group>


    <!-- Code -->
    <group id="CodeMenu" popup="true">
      <reference ref="OverrideMethods"/>
      <reference ref="ImplementMethods"/>
      <action id="Generate" class="com.intellij.codeInsight.generation.actions.GenerateAction"/>
      <separator/>
      <action id="SurroundWith" class="com.intellij.codeInsight.generation.actions.SurroundWithAction"/>
      <action id="Unwrap" class="com.intellij.codeInsight.unwrap.UnwrapAction"/>
      <separator/>

      <group id="CodeCompletionGroup" class="com.intellij.codeInsight.completion.actions.CodeCompletionGroup" popup="true">
        <action id="CodeCompletion" class="com.intellij.codeInsight.completion.actions.CodeCompletionAction"/>
        <action id="SmartTypeCompletion" class="com.intellij.codeInsight.completion.actions.SmartCodeCompletionAction"/>
        <separator/>
        <action id="HippieCompletion" class="com.intellij.codeInsight.completion.actions.HippieCompletionAction"/>
        <action id="HippieBackwardCompletion" class="com.intellij.codeInsight.completion.actions.HippieBackwardCompletionAction"/>
      </group>

      <group id="FoldingGroup" popup="true">
        <action id="ExpandRegion" class="com.intellij.codeInsight.folding.impl.actions.ExpandRegionAction"/>
        <action id="CollapseRegion" class="com.intellij.codeInsight.folding.impl.actions.CollapseRegionAction"/>
        <separator/>
        <action id="ExpandAllRegions" class="com.intellij.codeInsight.folding.impl.actions.ExpandAllRegionsAction"/>
        <action id="CollapseAllRegions" class="com.intellij.codeInsight.folding.impl.actions.CollapseAllRegionsAction"/>
        <separator/>
        <group id="LanguageSpecificFoldingGroup">
          <action id="ExpandDocComments" class="com.intellij.codeInsight.folding.impl.actions.ExpandDocCommentsAction"/>
          <action id="CollapseDocComments" class="com.intellij.codeInsight.folding.impl.actions.CollapseDocCommentsAction"/>
        </group>
        <separator/>
        <action id="CollapseSelection" class="com.intellij.codeInsight.folding.impl.actions.CollapseSelectionAction"/>
      </group>

      <separator/>

      <action id="InsertLiveTemplate" class="com.intellij.codeInsight.template.impl.actions.ListTemplatesAction"/>
      <action id="SurroundWithLiveTemplate" class="com.intellij.codeInsight.template.impl.actions.SurroundWithTemplateAction"/>
      <separator/>

      <group id="CommentGroup">
        <action id="CommentByLineComment" class="com.intellij.codeInsight.generation.actions.CommentByLineCommentAction"/>
        <action id="CommentByBlockComment" class="com.intellij.codeInsight.generation.actions.CommentByBlockCommentAction"/>
      </group>

      <group id="CodeFormatGroup">
        <action id="ReformatCode" class="com.intellij.codeInsight.actions.ReformatCodeAction"/>
        <action id="AutoIndentLines" class="com.intellij.codeInsight.generation.actions.AutoIndentLinesAction"/>
        <action id="OptimizeImports" class="com.intellij.codeInsight.actions.OptimizeImportsAction"/>
        <action id="RearrangeCode" class="com.intellij.application.options.codeStyle.arrangement.action.RearrangeCodeAction"/>
      </group>

      <separator/>
      <action id="MoveStatementDown" class="com.intellij.codeInsight.editorActions.moveUpDown.MoveStatementDownAction"/>
      <action id="MoveStatementUp" class="com.intellij.codeInsight.editorActions.moveUpDown.MoveStatementUpAction"/>
      <action id="MoveLineDown" class="com.intellij.codeInsight.editorActions.moveUpDown.MoveLineDownAction"/>
      <action id="MoveLineUp" class="com.intellij.codeInsight.editorActions.moveUpDown.MoveLineUpAction"/>
      <separator/>
      <add-to-group group-id="MainMenu" anchor="after" relative-to-action="GoToMenu"/>
    </group>

    <!-- Refactor -->
    <group id="RefactoringMenu" popup="true">
      <action id="Refactorings.QuickListPopupAction"
              class = "com.intellij.refactoring.actions.RefactoringQuickListPopupAction"
              text = "Refactor This..." description="Context aware popup with list of refactoring actions"/>
      <action id="RenameElement" class="com.intellij.refactoring.actions.RenameElementAction"/>
      <action id="ChangeSignature" class="com.intellij.refactoring.actions.ChangeSignatureAction"/>
      <separator/>
      <action id="Move" class="com.intellij.refactoring.actions.MoveAction"/>
      <action id="CopyElement" class="com.intellij.ide.actions.CopyElementAction"/>
      <action id="CloneElement" class="com.intellij.ide.actions.CloneElementAction"/>
      <action id="SafeDelete" class="com.intellij.refactoring.actions.SafeDeleteAction"/>
      <separator/>
      <group id="IntroduceActionsGroup" popup="true">
        <action id="IntroduceVariable" class="com.intellij.refactoring.actions.IntroduceVariableAction"/>
        <action id="IntroduceConstant" class="com.intellij.refactoring.actions.IntroduceConstantAction"/>
        <action id="IntroduceField" class="com.intellij.refactoring.actions.IntroduceFieldAction"/>
        <action id="IntroduceParameter" class="com.intellij.refactoring.actions.IntroduceParameterAction"/>
        <separator/>
        <action id="ExtractMethod" class="com.intellij.refactoring.actions.ExtractMethodAction"/>
        <separator/>
        <action id="ExtractClass" class="com.intellij.refactoring.actions.ExtractClassAction"/>
        <action id="ExtractInclude" class="com.intellij.refactoring.actions.ExtractIncludeAction"/>
        <action id="ExtractInterface" class="com.intellij.refactoring.actions.ExtractInterfaceAction"/>
        <action id="ExtractSuperclass" class="com.intellij.refactoring.actions.ExtractSuperclassAction"/>
        <action id="ExtractModule" class="com.intellij.refactoring.actions.ExtractModuleAction"/>
      </group>

      <action id="Inline" class="com.intellij.refactoring.actions.InlineAction"/>
      <separator/>
      <action id="MembersPullUp" class="com.intellij.refactoring.actions.PullUpAction"/>
      <action id="MemberPushDown" class="com.intellij.refactoring.actions.PushDownAction"/>
      <add-to-group group-id="MainMenu" anchor="after" relative-to-action="CodeMenu"/>
    </group>

    <!-- Run -->
    <group id="RunMenu" popup="true">
      <group id="RunnerActions"/>
      <reference ref="ChooseRunConfiguration"/>
      <reference ref="ChooseDebugConfiguration"/>
      <action id="editRunConfigurations" class="com.intellij.execution.actions.EditRunConfigurationsAction"/>
      <action id="Stop" class="com.intellij.execution.actions.StopAction" icon="AllIcons.Actions.Suspend"/>

      <add-to-group group-id="MainMenu" anchor="after" relative-to-action="RefactoringMenu"/>
    </group>


    <!-- Tools -->
    <group id="ToolsBasicGroup">
      <action id="SaveAsTemplate" class="com.intellij.codeInsight.template.actions.SaveAsTemplateAction"/>
      <action id="SaveFileAsTemplate" class="com.intellij.ide.actions.SaveFileAsTemplateAction"/>
      <separator/>

      <add-to-group group-id="ToolsMenu" anchor="first"/>
    </group>

    <group id="ExternalToolsGroup" class="com.intellij.tools.ExternalToolsGroup">
      <add-to-group group-id="ToolsMenu" anchor="last"/>
    </group>

    <action id="NewScratchFile" class="com.intellij.ide.scratch.CreateScratchFileAction">
      <add-to-group group-id="ToolsBasicGroup" anchor="first"/>
    </action>

    <group id="NewGroup" popup="true">
      <action id="NewFile" class="com.intellij.ide.actions.CreateFileAction"/>
      <action id="NewDir" class="com.intellij.ide.actions.CreateDirectoryOrPackageAction"/>
      <separator/>
      <action id="NewFromTemplate" class="com.intellij.ide.fileTemplates.actions.CreateFromTemplateGroup"/>
    </group>

    <group id="WeighingNewGroup" class="com.intellij.ide.actions.WeighingNewActionGroup"/>

    <!-- Toolbar -->
    <!--
    <group id="ToolbarNewElement">
      <action id="NewElementToolbarAction" class="com.intellij.ide.actions.NewElementToolbarAction" icon="/general/add.png"/>
      <add-to-group group-id="MainToolBar" anchor="first"/>
    </group>
    -->

    <group id="ToolbarFindGroup">
      <separator/>

      <reference ref="Find"/>
      <reference ref="Replace"/>

      <add-to-group group-id="MainToolBar" relative-to-action="$Paste" anchor="after"/>
    </group>

    <group id="ToolbarRunGroup">
      <separator/>
      <reference ref="RunConfiguration"/>
      <reference ref="RunnerActions"/>

      <add-to-group group-id="MainToolBar" relative-to-action="Forward" anchor="after"/>
    </group>

    <group id="NavBarToolBarOthers"/>
    <group id="NavBarToolBar">
      <reference ref="ToolbarRunGroup"/>
      <separator/>
      <reference ref="NavBarVcsGroup"/>
      <separator/>
      <reference id="NavBarToolBarOthers"/>
      <separator/>
      <reference ref="SearchEverywhere"/>
    </group>

    <group id="Bookmarks">
      <reference ref="ToggleBookmark"/>
      <reference ref="ShowBookmarks"/>
      <reference ref="GotoNextBookmark"/>
      <reference ref="GotoPreviousBookmark"/>

      <action id="GotoBookmark0" class="com.intellij.ide.bookmarks.actions.GotoBookmark0Action"/>
      <action id="GotoBookmark1" class="com.intellij.ide.bookmarks.actions.GotoBookmark1Action"/>
      <action id="GotoBookmark2" class="com.intellij.ide.bookmarks.actions.GotoBookmark2Action"/>
      <action id="GotoBookmark3" class="com.intellij.ide.bookmarks.actions.GotoBookmark3Action"/>
      <action id="GotoBookmark4" class="com.intellij.ide.bookmarks.actions.GotoBookmark4Action"/>
      <action id="GotoBookmark5" class="com.intellij.ide.bookmarks.actions.GotoBookmark5Action"/>
      <action id="GotoBookmark6" class="com.intellij.ide.bookmarks.actions.GotoBookmark6Action"/>
      <action id="GotoBookmark7" class="com.intellij.ide.bookmarks.actions.GotoBookmark7Action"/>
      <action id="GotoBookmark8" class="com.intellij.ide.bookmarks.actions.GotoBookmark8Action"/>
      <action id="GotoBookmark9" class="com.intellij.ide.bookmarks.actions.GotoBookmark9Action"/>

      <action id="ToggleBookmark0" class="com.intellij.ide.bookmarks.actions.ToggleBookmark0Action"/>
      <action id="ToggleBookmark1" class="com.intellij.ide.bookmarks.actions.ToggleBookmark1Action"/>
      <action id="ToggleBookmark2" class="com.intellij.ide.bookmarks.actions.ToggleBookmark2Action"/>
      <action id="ToggleBookmark3" class="com.intellij.ide.bookmarks.actions.ToggleBookmark3Action"/>
      <action id="ToggleBookmark4" class="com.intellij.ide.bookmarks.actions.ToggleBookmark4Action"/>
      <action id="ToggleBookmark5" class="com.intellij.ide.bookmarks.actions.ToggleBookmark5Action"/>
      <action id="ToggleBookmark6" class="com.intellij.ide.bookmarks.actions.ToggleBookmark6Action"/>
      <action id="ToggleBookmark7" class="com.intellij.ide.bookmarks.actions.ToggleBookmark7Action"/>
      <action id="ToggleBookmark8" class="com.intellij.ide.bookmarks.actions.ToggleBookmark8Action"/>
      <action id="ToggleBookmark9" class="com.intellij.ide.bookmarks.actions.ToggleBookmark9Action"/>

    </group>

    <group id="ProjectViewPopupMenuRefactoringGroup">
      <reference ref="RefactoringMenu"/>
    </group>

    <group id="ProjectViewPopupMenuModifyGroup">
      <reference ref="$Delete"/>
      <group id="MarkFileAs" class="com.intellij.openapi.file.exclude.ui.MarkFileGroup">
        <action id="MarkAsPlainTextAction" class="com.intellij.openapi.file.exclude.ui.MarkAsPlainTextAction"/>
        <action id="MarkAsOriginalTypeAction" class="com.intellij.openapi.file.exclude.ui.MarkAsOriginalTypeAction"/>
      </group>
    </group>

    <group id="ProjectViewPopupMenuRunGroup">
      <reference ref="RunContextPopupGroup"/>
    </group>

    <group id="ProjectViewPopupMenuSettingsGroup">
      <group id="MarkRootGroup" class="com.intellij.ide.projectView.actions.MarkRootGroup" popup="true">
      </group>
    </group>

    <group id="ProjectViewPopupMenu">
      <reference ref="WeighingNewGroup"/>
      <action id="AssociateWithFileType" class="com.intellij.ide.actions.AssociateFileType"/>
      <separator/>
      <reference ref="CutCopyPasteGroup"/>
      <reference ref="EditSource"/>
      <reference ref="ChangesView.ApplyPatch"/>
      <separator/>
      <reference ref="FindUsages"/>
      <reference ref="FindInPath"/>
      <reference ref="ReplaceInPath"/>
      <separator/>
      <reference ref="ProjectViewPopupMenuRefactoringGroup"/>
      <separator/>
      <reference ref="AddToFavorites"/>
      <separator/>
      <reference ref="ProjectViewPopupMenuModifyGroup"/>
      <separator/>
      <reference ref="ProjectViewPopupMenuRunGroup"/>
      <separator/>
      <reference ref="VersionControlsGroup"/>
      <action id="SynchronizeCurrentFile" class="com.intellij.ide.actions.SynchronizeCurrentFileAction" icon="AllIcons.Actions.Refresh"/>
      <separator/>
      <action id="RevealIn" class="com.intellij.ide.actions.RevealFileAction"/>
      <reference ref="ShowFilePath"/>
      <action id="GoToLinkTarget" class="com.intellij.ide.actions.GoToLinkTargetAction"/>
      <separator/>
      <reference ref="CompareTwoFiles"/>
      <reference ref="CompareFileWithEditor"/>
      <reference ref="CompareDirs"/>
      <reference ref="CompareJars"/>
      <separator/>
      <reference ref="ExternalToolsGroup"/>
      <separator/>
      <reference ref="ProjectViewPopupMenuSettingsGroup"/>
    </group>

    <group id="NavbarPopupMenu">
      <reference ref="WeighingNewGroup"/>
      <reference ref="AssociateWithFileType"/>
      <separator/>
      <reference ref="CutCopyPasteGroup"/>
      <reference ref="EditSource"/>
      <reference ref="ChangesView.ApplyPatch"/>
      <separator/>
      <reference ref="FindUsages"/>
      <reference ref="FindInPath"/>
      <reference ref="ReplaceInPath"/>
      <separator/>
      <reference ref="ProjectViewPopupMenuRefactoringGroup"/>
      <separator/>
      <reference ref="AddToFavorites"/>
      <separator/>
      <reference ref="ProjectViewPopupMenuModifyGroup"/>
      <separator/>
      <reference ref="ProjectViewPopupMenuRunGroup"/>
      <separator/>
      <reference ref="VersionControlsGroup"/>
      <reference ref="SynchronizeCurrentFile"/>
      <separator/>
      <reference ref="ExternalToolsGroup"/>
      <separator/>
      <reference ref="ProjectViewPopupMenuSettingsGroup"/>
    </group>

    <group id="FavoritesViewPopupMenu">
      <reference ref="NewGroup"/>
      <reference ref="AssociateWithFileType"/>
      <separator/>
      <reference ref="CutCopyPasteGroup"/>
      <reference ref="EditSource"/>
      <reference ref="ChangesView.ApplyPatch"/>
      <separator/>
      <reference ref="FindUsages"/>
      <reference ref="FindInPath"/>
      <reference ref="ReplaceInPath"/>
      <separator/>
      <reference ref="ProjectViewPopupMenuRefactoringGroup"/>
      <separator/>
      <action id="RenameFavoritesList" class="com.intellij.ide.favoritesTreeView.actions.RenameFavoritesListAction" use-shortcut-of="RenameElement"/>
      <action id="RemoveFromFavorites" class="com.intellij.ide.favoritesTreeView.actions.DeleteFromFavoritesAction"/>
      <action id="EditFavorites" class="com.intellij.ide.favoritesTreeView.actions.EditFavoritesAction"/>
      <reference ref="AddToFavorites"/>
      <reference ref="SendToFavoritesGroup"/>
      <separator/>
      <reference ref="ProjectViewPopupMenuModifyGroup"/>
      <separator/>
      <reference ref="ProjectViewPopupMenuRunGroup"/>
      <separator/>
      <reference ref="VersionControlsGroup"/>
      <reference ref="SynchronizeCurrentFile"/>
      <separator/>
      <reference ref="RevealIn"/>
      <reference ref="ShowFilePath"/>
      <separator/>
      <reference ref="CompareTwoFiles"/>
      <reference ref="CompareFileWithEditor"/>
      <separator/>
      <reference ref="ExternalToolsGroup"/>
      <separator/>
      <reference ref="ProjectViewPopupMenuSettingsGroup"/>
    </group>

    <group id="ScopeViewPopupMenu">
      <reference ref="ProjectViewPopupMenu"/>
      <separator/>
      <action id="ScopeView.EditScopes" class="com.intellij.ide.scopeView.EditScopesAction"/>
    </group>

    <group id="StructureViewPopupMenu">
      <reference ref="EditSource"/>
      <separator/>
      <reference ref="FindUsages"/>
      <reference ref="RefactoringMenu"/>
      <separator/>
      <reference ref="AddToFavorites"/>
      <separator/>
      <reference ref="CutCopyPasteGroup"/>
      <separator/>
      <reference ref="RunContextPopupGroup"/>
      <reference ref="VersionControlsGroup"/>
      <separator/>
      <reference ref="CompareTwoFiles"/>
    </group>

    <group id="EditorPopupMenu1">
      <separator/>
      <reference ref="FindUsages"/>
      <reference ref="RefactoringMenu"/>
      <separator/>
      <reference ref="FoldingGroup"/>
      <separator/>

      <add-to-group group-id="EditorPopupMenu" relative-to-action="EditorToggleColumnMode" anchor="after"/>
    </group>

    <group id="EditorLangPopupMenu">
      <separator/>
      <group id="EditorPopupMenu.GoTo" popup="true">
        <reference ref="ShowNavBar"/>
        <reference ref="GotoDeclaration"/>
        <reference ref="GotoImplementation"/>
        <reference ref="GotoTypeDeclaration"/>
        <reference ref="GotoSuperMethod"/>
        <reference ref="GotoTest"/>
      </group>
      <reference ref="Generate"/>
      <separator/>

      <group id="EditorPopupMenu.Run">
        <reference ref="RunContextPopupGroup"/>
      </group>
      <separator/>
      <reference ref="VersionControlsGroup"/>
      <separator/>
      <reference ref="ExternalToolsGroup"/>

      <add-to-group group-id="EditorPopupMenu" relative-to-action="CompareClipboardWithSelection" anchor="before"/>
    </group>

    <group id="EditorTabPopupMenuEx">
      <separator/>
      <reference ref="AddToFavorites"/>
      <reference ref="AddAllToFavorites"/>
      <separator/>
      <reference ref="RunContextPopupGroup"/>
      <separator/>
      <reference ref="VersionControlsGroup"/>
      <separator/>
      <reference ref="ExternalToolsGroup"/>

      <add-to-group group-id="EditorTabPopupMenu" anchor="last"/>
    </group>

    <reference ref="ChangeTemplateDataLanguage">
      <add-to-group group-id="EditorPopupMenu" anchor="before" relative-to-action="ToggleReadOnlyAttribute"/>
    </reference>

    <group id="UsageView.Popup">
      <reference ref="EditSource"/>
      <action id="UsageView.Include" class="com.intellij.usages.actions.IncludeUsageAction"/>
      <action id="UsageView.Exclude" class="com.intellij.usages.actions.ExcludeUsageAction" use-shortcut-of="$Delete"/>
      <separator/>
      <action id="UsageView.ShowRecentFindUsages" class="com.intellij.find.impl.ShowRecentFindUsagesAction" icon="AllIcons.Actions.Back"
              use-shortcut-of="RecentFiles"/>
    </group>

    <!-- <action id="UsageView.ImportToFavorites" class="com.intellij.ide.favoritesTreeView.ImportUsagesAction"/> -->
    <action id="NewElementSamePlace" class="com.intellij.ide.actions.NewElementSamePlaceAction"/>

    <action id="ChangeCodeStyleScheme" class="com.intellij.ide.actions.QuickChangeCodeStyleSchemeAction">
      <add-to-group group-id="ChangeScheme" anchor="after" relative-to-action="ChangeColorScheme"/>
    </action>

    <action id="TypeHierarchyBase.BaseOnThisType" text="Base on This Type" class="com.intellij.ide.hierarchy.TypeHierarchyBrowserBase$BaseOnThisTypeAction"/>
    <action id="TypeHierarchy.Class" class="com.intellij.ide.hierarchy.ViewClassHierarchyAction"/>
    <action id="TypeHierarchy.Subtypes" class="com.intellij.ide.hierarchy.ViewSubtypesHierarchyAction"/>
    <action id="TypeHierarchy.Supertypes" class="com.intellij.ide.hierarchy.ViewSupertypesHierarchyAction"/>

    <action id="EditBreakpoint" class="com.intellij.xdebugger.impl.actions.EditBreakpointAction"/>
    <group id="DebugMainMenu">
      <separator/>
      <action id="StepOver" class="com.intellij.xdebugger.impl.actions.StepOverAction" icon="AllIcons.Actions.TraceOver"/>
      <action id="ForceStepOver" class="com.intellij.xdebugger.impl.actions.ForceStepOverAction" icon="AllIcons.Debugger.Actions.Force_step_over"/>
      <action id="StepInto" class="com.intellij.xdebugger.impl.actions.StepIntoAction" icon="AllIcons.Actions.TraceInto"/>
      <action id="ForceStepInto" class="com.intellij.xdebugger.impl.actions.ForceStepIntoAction" icon="AllIcons.Debugger.Actions.Force_step_into"/>
      <action id="SmartStepInto" class="com.intellij.xdebugger.impl.actions.SmartStepIntoAction" icon="AllIcons.Actions.TraceInto"/>
      <action id="StepOut" class="com.intellij.xdebugger.impl.actions.StepOutAction" icon="AllIcons.Actions.StepOut"/>
      <action id="RunToCursor" class="com.intellij.xdebugger.impl.actions.RunToCursorAction" icon="AllIcons.Actions.RunToCursor"/>
      <action id="ForceRunToCursor" class="com.intellij.xdebugger.impl.actions.ForceRunToCursorAction" icon="AllIcons.Debugger.Actions.Force_run_to_cursor"/>
      <action id="Pause" class="com.intellij.xdebugger.impl.actions.PauseAction" icon="AllIcons.Actions.Pause"/>
      <action id="Resume" class="com.intellij.xdebugger.impl.actions.ResumeAction" icon="AllIcons.Actions.Resume"/>
      <separator/>
      <action id="EvaluateExpression" class="com.intellij.xdebugger.impl.actions.EvaluateAction" icon="AllIcons.Debugger.EvaluateExpression"/>
      <action id="QuickEvaluateExpression" class="com.intellij.xdebugger.impl.actions.QuickEvaluateAction"/>
      <action id="ShowExecutionPoint" class="com.intellij.xdebugger.impl.actions.ShowExecutionPointAction"
              icon="AllIcons.Debugger.ShowCurrentFrame"/>
      <separator/>
      <action id="ToggleLineBreakpoint" class="com.intellij.xdebugger.impl.actions.ToggleLineBreakpointAction"/>
      <action id="ToggleTemporaryLineBreakpoint" class="com.intellij.xdebugger.impl.actions.ToggleTemporaryLineBreakpointAction"/>
      <action id="ViewBreakpoints" class="com.intellij.xdebugger.impl.actions.ViewBreakpointsAction" icon="AllIcons.Debugger.ViewBreakpoints"/>
      <separator/>

      <add-to-group group-id="RunMenu" anchor="last"/>
    </group>

    <action id="Debugger.AddToWatch" class="com.intellij.xdebugger.impl.actions.AddToWatchesAction" icon="AllIcons.Debugger.AddToWatch"/>
    <action id="Debugger.EvaluateInConsole" class="com.intellij.xdebugger.impl.actions.EvaluateInConsoleAction"/>

    <group id="EditorPopupMenuDebug">
      <separator/>
      <reference ref="EvaluateExpression"/>
      <reference ref="RunToCursor"/>
      <reference ref="ForceRunToCursor"/>
      <reference ref="Debugger.AddToWatch"/>
      <reference ref="Debugger.EvaluateInConsole"/>
      <separator/>

      <add-to-group group-id="EditorLangPopupMenu" relative-to-action="EditorPopupMenu.Run" anchor="before"/>
    </group>


    <group id="XDebugger.Actions">
      <action id="XDebugger.SetValue" class="com.intellij.xdebugger.impl.ui.tree.actions.XSetValueAction"/>
      <action id="XDebugger.CopyValue" class="com.intellij.xdebugger.impl.ui.tree.actions.XCopyValueAction"/>
      <action id="XDebugger.CompareValueWithClipboard" class="com.intellij.xdebugger.impl.ui.tree.actions.XCompareWithClipboardAction"/>
      <action id="XDebugger.CopyName" class="com.intellij.xdebugger.impl.ui.tree.actions.XCopyNameAction"/>
      <action id="XDebugger.Inspect" class="com.intellij.xdebugger.impl.ui.tree.actions.XInspectAction"/>
      <action id="XDebugger.JumpToSource" class="com.intellij.xdebugger.impl.ui.tree.actions.XJumpToSourceAction"/>
      <action id="XDebugger.JumpToTypeSource" class="com.intellij.xdebugger.impl.ui.tree.actions.XJumpToTypeSourceAction"/>

      <action id="Debugger.Tree.AddToWatches" class="com.intellij.xdebugger.impl.ui.tree.actions.XAddToWatchesAction" icon="AllIcons.Debugger.AddToWatch"/>
      <action id="Debugger.Tree.EvaluateInConsole" class="com.intellij.xdebugger.impl.ui.tree.actions.EvaluateInConsoleFromTreeAction"/>

      <action id="XDebugger.NewWatch" class="com.intellij.xdebugger.impl.frame.actions.XNewWatchAction" icon="AllIcons.Debugger.NewWatch"/>
      <action id="XDebugger.EditWatch" class="com.intellij.xdebugger.impl.frame.actions.XEditWatchAction"/>
      <action id="XDebugger.RemoveWatch" class="com.intellij.xdebugger.impl.frame.actions.XRemoveWatchAction" icon="AllIcons.Actions.Delete"/>
      <action id="XDebugger.RemoveAllWatches" class="com.intellij.xdebugger.impl.frame.actions.XRemoveAllWatchesAction"/>
      <action id="XDebugger.MuteBreakpoints" class="com.intellij.xdebugger.impl.actions.MuteBreakpointAction"
              icon="AllIcons.Debugger.MuteBreakpoints"/>
      <action id="XDebugger.AutoTooltip" class="com.intellij.xdebugger.impl.actions.ValueTooltipAutoShowAction"/>
      <action id="XDebugger.ToggleSortValues" class="com.intellij.xdebugger.impl.ui.tree.actions.SortValuesToggleAction" icon="AllIcons.ObjectBrowser.Sorted"/>
      <action id="Debugger.MarkObject" class="com.intellij.xdebugger.impl.actions.MarkObjectAction"/>
    </group>

    <group id="XDebugger.ToolWindow.TopToolbar">
      <reference ref="ShowExecutionPoint"/>
      <separator/>
      <reference ref="StepOver"/>
      <reference ref="StepInto"/>
      <reference ref="ForceStepInto"/>
      <reference ref="StepOut"/>
      <reference ref="RunToCursor"/>
      <separator/>
      <reference ref="EvaluateExpression" />
    </group>

    <group id="XDebugger.ToolWindow.LeftToolbar">
      <reference ref="Resume"/>
      <reference ref="Pause"/>
      <reference ref="Stop"/>
      <separator/>
      <reference ref="ViewBreakpoints"/>
      <reference ref="XDebugger.MuteBreakpoints"/>
    </group>

    <group id="XDebugger.ValueGroup" popup="false">
      <reference ref="XDebugger.Inspect"/>
      <reference ref="XDebugger.SetValue"/>
      <reference ref="XDebugger.CopyValue"/>
      <reference ref="XDebugger.CompareValueWithClipboard"/>
      <reference ref="XDebugger.CopyName"/>
      <reference ref="Debugger.MarkObject"/>
    </group>

    <group id="XDebugger.Evaluation.Dialog.Tree.Popup">
      <reference ref="XDebugger.ValueGroup"/>
    </group>

    <group id="XDebugger.Variables.Tree.Popup">
      <reference ref="XDebugger.ValueGroup"/>
      <reference ref="XDebugger.JumpToSource"/>
      <reference ref="XDebugger.JumpToTypeSource"/>
      <reference ref="Debugger.Tree.AddToWatches"/>
      <reference ref="Debugger.Tree.EvaluateInConsole"/>
    </group>

    <group id="XDebugger.Variables.Tree.Toolbar">
    </group>

    <group id="XDebugger.Watches.Tree.Popup">
      <reference ref="XDebugger.NewWatch"/>
      <reference ref="XDebugger.RemoveWatch"/>
      <reference ref="XDebugger.RemoveAllWatches"/>
      <reference ref="XDebugger.EditWatch"/>
      <reference ref="XDebugger.ValueGroup"/>
    </group>

    <group id="XDebugger.Watches.Tree.Toolbar">
      <reference ref="XDebugger.NewWatch"/>
      <reference ref="XDebugger.RemoveWatch"/>
    </group>

    <group id="XDebugger.Inspect.Tree.Popup">
      <reference ref="XDebugger.ValueGroup"/>
      <reference ref="Debugger.Tree.AddToWatches"/>
      <reference ref="Debugger.Tree.EvaluateInConsole"/>
    </group>

    <group id="XDebugger.Settings" icon="AllIcons.General.SecondaryGroup" popup="true">

    </group>

    <group id="RunnerLayoutActions">
      <group id="Runner.Layout">
        <action id="Runner.RestoreLayout" class="com.intellij.execution.ui.layout.actions.RestoreLayoutAction"
                icon="AllIcons.Debugger.RestoreLayout"/>
      </group>
      <group id="Runner.View.Close.Group" popup="false">
        <action id="Runner.CloseView" class="com.intellij.execution.ui.layout.actions.CloseViewAction" icon="AllIcons.Actions.Cross"/>
        <action id="Runner.CloseOtherViews" class="com.intellij.execution.ui.layout.actions.CloseOtherViewsAction" icon="AllIcons.Actions.Cross"/>
        <action id="Runner.CloseAllViews" class="com.intellij.execution.ui.layout.actions.CloseAllViewsAction" icon="AllIcons.Actions.Cross"/>
        <action id="Runner.CloseAllUnpinnedViews" class="com.intellij.execution.ui.layout.actions.CloseAllUnpinnedViewsAction" icon="AllIcons.Actions.Cross"/>
      </group>
      <group id="Runner.View.Popup">
        <action id="Runner.MinimizeView" class="com.intellij.execution.ui.layout.actions.MinimizeViewAction" icon="AllIcons.Actions.Minimize"/>
        <separator/>
        <reference ref="Runner.View.Close.Group"/>
        <separator/>
        <group id="Runner.Focus">
          <action id="Runner.FocusOnStartup" class="com.intellij.execution.ui.actions.FocusOnStartAction"/>
        </group>
      </group>


      <group id="Runner.View.Toolbar">
        <reference ref="Runner.MinimizeView"/>
        <reference ref="Runner.CloseView"/>
      </group>
    </group>

    <group id="LocalHistory" class="com.intellij.history.integration.ui.actions.LocalHistoryGroup" popup="true">
      <action id="LocalHistory.ShowHistory" class="com.intellij.history.integration.ui.actions.ShowHistoryAction"/>
      <action id="LocalHistory.ShowSelectionHistory" class="com.intellij.history.integration.ui.actions.ShowSelectionHistoryAction"/>
      <action id="LocalHistory.PutLabel" class="com.intellij.history.integration.ui.actions.PutLabelAction"/>

      <add-to-group group-id="VersionControlsGroup" anchor="first"/>
      <add-to-group group-id="VcsGroups" anchor="first"/>
    </group>

    <group id="TestTreePopupMenu">
      <reference ref="RunContextGroup"/>
      <separator/>
      <reference ref="EditSource"/>
      <reference ref="ViewSource"/>
    </group>

    <group id="ConsoleView.PopupMenu">
      <reference ref="ConsoleEditorPopupMenu"/>
      <separator/>
      <action id="ConsoleView.ClearAll" class="com.intellij.execution.impl.ConsoleViewImpl$ClearAllAction"/>
    </group>

    <group>
      <action class="com.intellij.execution.testframework.actions.ViewAssertEqualsDiffAction" text="View assertEquals Difference" id="openAssertEqualsDiff"/>
      <separator/>
      <add-to-group anchor="first" group-id="TestTreePopupMenu"/>
    </group>
    <!-- SM Test Runner Actions -->
    <group id="SMTestRunnerTestsTree">
      <separator/>
      <action id="com.intellij.execution.testframework.sm.runner.ui.statistics.ShowStatisticsAction"
              class="com.intellij.execution.testframework.sm.runner.ui.statistics.ShowStatisticsAction"
              text="Show Statistics"/>
      <add-to-group group-id="TestTreePopupMenu" anchor="last"/>
    </group>
    <group id="SMTestRunnerStatistics">
      <separator/>
      <action id="com.intellij.execution.testframework.sm.runner.ui.statistics.ShowTestProxy"
              class="com.intellij.execution.testframework.sm.runner.ui.statistics.ShowTestProxy"
              text="Navigate to Test"/>
      <add-to-group group-id="TestTreePopupMenu" anchor="last"/>
    </group>

    <action id="DumpLookupElementWeights" class="com.intellij.internal.DumpLookupElementWeights" text="Dump lookup element weights to log">
      <add-to-group group-id="MaintenanceGroup" anchor="last"/>
    </action>

    <action id="Arrangement.Rule.Add" class="com.intellij.application.options.codeStyle.arrangement.action.AddArrangementRuleAction"/>
    <action id="Arrangement.Rule.Remove" class="com.intellij.application.options.codeStyle.arrangement.action.RemoveArrangementRuleAction"/>
    <action id="Arrangement.Rule.Edit"
            class="com.intellij.application.options.codeStyle.arrangement.action.EditArrangementRuleAction"
            icon="AllIcons.Actions.Edit"/>
    <action id="Arrangement.Rule.Match.Condition.Move.Up"
            class="com.intellij.application.options.codeStyle.arrangement.action.MoveArrangementMatchingRuleUpAction"
            icon="AllIcons.ToolbarDecorator.MoveUp"/>
    <action id="Arrangement.Rule.Match.Condition.Move.Down"
            class="com.intellij.application.options.codeStyle.arrangement.action.MoveArrangementMatchingRuleDownAction"
            icon="AllIcons.ToolbarDecorator.MoveDown"/>
    <action id="Arrangement.Rule.Group.Condition.Move.Up"
            class="com.intellij.application.options.codeStyle.arrangement.action.MoveArrangementGroupingRuleUpAction"
            icon="AllIcons.ToolbarDecorator.MoveUp"/>
    <action id="Arrangement.Rule.Group.Condition.Move.Down"
            class="com.intellij.application.options.codeStyle.arrangement.action.MoveArrangementGroupingRuleDownAction"
            icon="AllIcons.ToolbarDecorator.MoveDown"/>

    <group id="Arrangement.Rule.Match.Control.Context.Menu">
      <reference ref="Arrangement.Rule.Add"/>
      <reference ref="Arrangement.Rule.Remove"/>
      <reference ref="Arrangement.Rule.Edit"/>
    </group>

    <group id="Arrangement.Rule.Match.Control.ToolBar">
      <reference ref="Arrangement.Rule.Add"/>
      <reference ref="Arrangement.Rule.Remove"/>
      <reference ref="Arrangement.Rule.Match.Condition.Move.Up"/>
      <reference ref="Arrangement.Rule.Match.Condition.Move.Down"/>
    </group>

    <group id="Arrangement.Rule.Group.Control.ToolBar">
      <reference ref="Arrangement.Rule.Group.Condition.Move.Up"/>
      <reference ref="Arrangement.Rule.Group.Condition.Move.Down"/>
    </group>

  </actions>
</component>
